unit ACConsts;
{
  Copyright (c) 2004, aa, Inge DR. & Adrian Hafizh.
  Property of PT SOFTINDO Jakarta.
  All rights reserved.

  mailto:aa|AT|softindo|DOT|net,
  http://delphi.softindo.net

  Version: 1.0.2
  Dated: 2004.12.01
}

{$J-} // these are truly constants
interface

const
  CR_ = #10;
  LF_ = #13;
  CRLF = #13#10;
  CHAR_TAB = #9;
  CHAR_COLON = ':';
  CHAR_DOT = '.';
  CHAR_DASH = '-';
  CHAR_SLASH = '/';
  CHAR_BACKSLASH = '\';
  CHAR_STAR = '*';
  CHAR_SPACE = ' ';
  CHAR_ZERO = '0';
  CHAR_COMMA = ',';

  COMMA = CHAR_COMMA;
  SPACE = CHAR_SPACE;
  COMMASPACE = CHAR_COMMA + CHAR_SPACE;
  COLLONSPACE = CHAR_COLON + CHAR_SPACE;

  DEFAULT_DELIMITER = COMMA;

  TABCT = CHAR_TAB + CHAR_COLON + CHAR_TAB;
  TABCS = CHAR_TAB + CHAR_COLON + CHAR_SPACE;

  ESCAPE = #27;
  BKSPACE = #8;
  BACKSPACE = BKSPACE;

  CR2: string[2] = CR_ + CR_;
  TAB2: string[2] = CHAR_TAB + CHAR_TAB;
  CRLF2: string[4] = CRLF + CRLF;

  YES = TRUE;
  NAY = not TRUE;
  OFF = not TRUE;

  OOH = not YES; NOO = OOH; //that means OOH-NOO equal with NAY

  IYA = TRUE;
  Enggak = not IYA;
  GAK = Enggak;

  DECIMAL_DIGIT = ['0'..'9'];
  NUMERIC = DECIMAL_DIGIT;

  HEXLOCASE = NUMERIC + ['a'..'f'];
  HEXUPCASE = NUMERIC + ['A'..'F'];

  HEXDIGITS = HEXLOCASE + HEXUPCASE;

  ALPHALOCASE = ['a'..'z'];
  ALPHAUPCASE = ['A'..'Z'];

  ALPHABET = ALPHALOCASE + ALPHAUPCASE;
  ALPHANUMERIC = ALPHABET + NUMERIC;

  COMMON_NAVIGATIONKEYS = [BACKSPACE, CHAR_TAB, CR_, LF_, ESCAPE];

  DEFAULT_BLOCKDIGITS = 5;
  DEFAULT_DELIMITERS = [',', '.', '-', ' ', ':', '/', '=']; //[',', '.', '-', ' ',':','/'];

//var
//  __DELIMITERS: set of char = DEFAULT_DELIMITERS;
//  __HEXNUM_UPPERCASE: string[16] = '0123456789ABCDEF';
//  __HEXNUM_LOWERCASE: string[16] = '0123456789abcdef';

  __CRC32Poly__ = integer($EDB88320); // widely used CRC32 Polynomial
  __AAMAGIC0__ = $19091969; // my birthdate
  __AAMAGIC1__ = $22101969; // my wife's birthdate
  __AAMAGIC2__ = $09022004; // my (first) son's birthdate

  _Error_ = 'Error ';
  Elipsis = '...';
  Unknown = 'Unknown';

type
  TChar_AlphaUpCase = 'A'..'Z';
  TChar_AlphaLoCase = 'a'..'z';
  TChar_Numeric = '0'..'9';
  TChar_HexLoCase = 'a'..'f';
  TChar_HexUpCase = 'A'..'F';
  TChar_Control = #0..#$1F;

  TWords = packed array of word;
  TArWords = packed array of TWords;
  TInts = packed array of integer;
  TArInts = packed array of TInts;
  TStrs = packed array of string;
  TBools = packed array of boolean;

//resourcestring
//  Err_fOpen = _Error_ + 'opening file ';
//  Err_fRead = _Error_ + 'reading file ';
//  Err_fWrite = _Error_ + 'writing file ';
//  Err_fCreate = _Error_ + 'creating file ';
//  Err_Proceed = _Error_ + 'proceeding';

const
  MaxCardinal = 4294967295; // high(Cardinal), 10 digits
  MaxInt64 = 9223372036854775807; // high(Int64), 19 digits
  MaxCardinal64S = '18446744073709551615'; // unsigned Int64, 20 digits
  MaxInt64x = $7FFFFFFFFFFFFFFF;
  EXTPI = 3.141592653589793238462643383279502884197169399375105820974944592307;

{.$DEFINE BIGNUM_CONSTS}
{$IFDEF BIGNUM_CONSTS}

  //PIX128: array[1..10] of cardinal =
  //($2902, $1CD1, $80DC, $628B, $C4C6, $C234, 0020550, 0155242, 0144417, 0040000);

  // specifying a larger base might help bc a bit faster?
  //
  // .echo.|time & echo scale=20000;base=64;4*a(1)|bc -lq>pinx & echo.|time
  // The current time is:  3:32:07.90
  // Enter the new time:
  // The current time is:  4:12:50.20
  // Enter the new time:
  // .
  // btw, above; my NT (also BSD)'s prompt is a DOT, period
  PINX =
    '3.141592653589793238462643383279502884197169399375105820974944592307' + //\
    '81640628620899862803482534211706798214808651328230664709384460955058' + //\
    '22317253594081284811174502841027019385211055596446229489549303819644' + //\
    '28810975665933446128475648233786783165271201909145648566923460348610' + //\
    '45432664821339360726024914127372458700660631558817488152092096282925' + //\
    '40917153643678925903600113305305488204665213841469519415116094330572' + //\
    '70365759591953092186117381932611793105118548074462379962749567351885' + //\
    '75272489122793818301194912983367336244065664308602139494639522473719' + //\
    '07021798609437027705392171762931767523846748184676694051320005681271' + //\
    '45263560827785771342757789609173637178721468440901224953430146549585' + //\
    '37105079227968925892354201995611212902196086403441815981362977477130' + //\
    '99605187072113499999983729780499510597317328160963185950244594553469' + //\
    '08302642522308253344685035261931188171010003137838752886587533208381' + //\
    '42061717766914730359825349042875546873115956286388235378759375195778' + //\
    '18577805321712268066130019278766111959092164201989380952572010654858' + //\
    '63278865936153381827968230301952035301852968995773622599413891249721' + //\
    '77528347913151557485724245415069595082953311686172785588907509838175' + //\
    '46374649393192550604009277016711390098488240128583616035637076601047' + //\
    '10181942955596198946767837449448255379774726847104047534646208046684' + //\
    '25906949129331367702898915210475216205696602405803815019351125338243' + //\
    '00355876402474964732639141992726042699227967823547816360093417216412' + //\
    '19924586315030286182974555706749838505494588586926995690927210797509' + //\
    '30295532116534498720275596023648066549911988183479775356636980742654' + //\
    '25278625518184175746728909777727938000816470600161452491921732172147' + //\
    '72350141441973568548161361157352552133475741849468438523323907394143' + //\
    '33454776241686251898356948556209921922218427255025425688767179049460' + //\
    '16534668049886272327917860857843838279679766814541009538837863609506' + //\
    '80064225125205117392984896084128488626945604241965285022210661186306' + //\
    '74427862203919494504712371378696095636437191728746776465757396241389' + //\
    '08658326459958133904780275900994657640789512694683983525957098258226' + //\
    '20522489407726719478268482601476990902640136394437455305068203496252' + //\
    '45174939965143142980919065925093722169646151570985838741059788595977' + //\
    '29754989301617539284681382686838689427741559918559252459539594310499' + //\
    '72524680845987273644695848653836736222626099124608051243884390451244' + //\
    '13654976278079771569143599770012961608944169486855584840635342207222' + //\
    '58284886481584560285060168427394522674676788952521385225499546667278' + //\
    '23986456596116354886230577456498035593634568174324112515076069479451' + //\
    '09659609402522887971089314566913686722874894056010150330861792868092' + //\
    '08747609178249385890097149096759852613655497818931297848216829989487' + //\
    '22658804857564014270477555132379641451523746234364542858444795265867' + //\
    '82105114135473573952311342716610213596953623144295248493718711014576' + //\
    '54035902799344037420073105785390621983874478084784896833214457138687' + //\
    '51943506430218453191048481005370614680674919278191197939952061419663' + //\
    '42875444064374512371819217999839101591956181467514269123974894090718' + //\
    '64942319615679452080951465502252316038819301420937621378559566389377' + //\
    '87083039069792077346722182562599661501421503068038447734549202605414' + //\
    '66592520149744285073251866600213243408819071048633173464965145390579' + //\
    '62685610055081066587969981635747363840525714591028970641401109712062' + //\
    '80439039759515677157700420337869936007230558763176359421873125147120' + //\
    '53292819182618612586732157919841484882916447060957527069572209175671' + //\
    '16722910981690915280173506712748583222871835209353965725121083579151' + //\
    '36988209144421006751033467110314126711136990865851639831501970165151' + //\
    '16851714376576183515565088490998985998238734552833163550764791853589' + //\
    '32261854896321329330898570642046752590709154814165498594616371802709' + //\
    '81994309924488957571282890592323326097299712084433573265489382391193' + //\
    '25974636673058360414281388303203824903758985243744170291327656180937' + //\
    '73444030707469211201913020330380197621101100449293215160842444859637' + //\
    '66983895228684783123552658213144957685726243344189303968642624341077' + //\
    '32269780280731891544110104468232527162010526522721116603966655730925' + //\
    '47110557853763466820653109896526918620564769312570586356620185581007' + //\
    '29360659876486117910453348850346113657686753249441668039626579787718' + //\
    '55608455296541266540853061434443185867697514566140680070023787765913' + //\
    '44017127494704205622305389945613140711270004078547332699390814546646' + //\
    '45880797270826683063432858785698305235808933065757406795457163775254' + //\
    '20211495576158140025012622859413021647155097925923099079654737612551' + //\
    '76567513575178296664547791745011299614890304639947132962107340437518' + //\
    '95735961458901938971311179042978285647503203198691514028708085990480' + //\
    '10941214722131794764777262241425485454033215718530614228813758504306' + //\
    '33217518297986622371721591607716692547487389866549494501146540628433' + //\
    '66393790039769265672146385306736096571209180763832716641627488880078' + //\
    '69256029022847210403172118608204190004229661711963779213375751149595' + //\
    '01566049631862947265473642523081770367515906735023507283540567040386' + //\
    '74351362222477158915049530984448933309634087807693259939780541934144' + //\
    '73774418426312986080998886874132604721569516239658645730216315981931' + //\
    '95167353812974167729478672422924654366800980676928238280689964004824' + //\
    '35403701416314965897940924323789690706977942236250822168895738379862' + //\
    '30015937764716512289357860158816175578297352334460428151262720373431' + //\
    '46531977774160319906655418763979293344195215413418994854447345673831' + //\
    '62499341913181480927777103863877343177207545654532207770921201905166' + //\
    '09628049092636019759882816133231666365286193266863360627356763035447' + //\
    '76280350450777235547105859548702790814356240145171806246436267945612' + //\
    '75318134078330336254232783944975382437205835311477119926063813346776' + //\
    '87969597030983391307710987040859133746414428227726346594704745878477' + //\
    '87201927715280731767907707157213444730605700733492436931138350493163' + //\
    '12840425121925651798069411352801314701304781643788518529092854520116' + //\
    '58393419656213491434159562586586557055269049652098580338507224264829' + //\
    '39728584783163057777560688876446248246857926039535277348030480290058' + //\
    '76075825104747091643961362676044925627420420832085661190625454337213' + //\
    '15359584506877246029016187667952406163425225771954291629919306455377' + //\
    '99140373404328752628889639958794757291746426357455254079091451357111' + //\
    '36941091193932519107602082520261879853188770584297259167781314969900' + //\
    '90192116971737278476847268608490033770242429165130050051683233643503' + //\
    '89517029893922334517220138128069650117844087451960121228599371623130' + //\
    '17114448464090389064495444006198690754851602632750529834918740786680' + //\
    '88183385102283345085048608250393021332197155184306354550076682829493' + //\
    '04137765527939751754613953984683393638304746119966538581538420568533' + //\
    '86218672523340283087112328278921250771262946322956398989893582116745' + //\
    '62701021835646220134967151881909730381198004973407239610368540664319' + //\
    '39509790190699639552453005450580685501956730229219139339185680344903' + //\
    '98205955100226353536192041994745538593810234395544959778377902374216' + //\
    '17271117236434354394782218185286240851400666044332588856986705431547' + //\
    '06965747458550332323342107301545940516553790686627333799585115625784' + //\
    '32298827372319898757141595781119635833005940873068121602876496286744' + //\
    '60477464915995054973742562690104903778198683593814657412680492564879' + //\
    '85561453723478673303904688383436346553794986419270563872931748723320' + //\
    '83760112302991136793862708943879936201629515413371424892830722012690' + //\
    '14754668476535761647737946752004907571555278196536213239264061601363' + //\
    '58155907422020203187277605277219005561484255518792530343513984425322' + //\
    '34157623361064250639049750086562710953591946589751413103482276930624' + //\
    '74353632569160781547818115284366795706110861533150445212747392454494' + //\
    '54236828860613408414863776700961207151249140430272538607648236341433' + //\
    '46235189757664521641376796903149501910857598442391986291642193994907' + //\
    '23623464684411739403265918404437805133389452574239950829659122850855' + //\
    '58215725031071257012668302402929525220118726767562204154205161841634' + //\
    '84756516999811614101002996078386909291603028840026910414079288621507' + //\
    '84245167090870006992821206604183718065355672525325675328612910424877' + //\
    '61825829765157959847035622262934860034158722980534989650226291748788' + //\
    '20273420922224533985626476691490556284250391275771028402799806636582' + //\
    '54889264880254566101729670266407655904290994568150652653053718294127' + //\
    '03369313785178609040708667114965583434347693385781711386455873678123' + //\
    '01458768712660348913909562009939361031029161615288138437909904231747' + //\
    '33639480457593149314052976347574811935670911013775172100803155902485' + //\
    '30906692037671922033229094334676851422144773793937517034436619910403' + //\
    '37511173547191855046449026365512816228824462575916333039107225383742' + //\
    '18214088350865739177150968288747826569959957449066175834413752239709' + //\
    '68340800535598491754173818839994469748676265516582765848358845314277' + //\
    '56879002909517028352971634456212964043523117600665101241200659755851' + //\
    '27617858382920419748442360800719304576189323492292796501987518721272' + //\
    '67507981255470958904556357921221033346697499235630254947802490114195' + //\
    '21238281530911407907386025152274299581807247162591668545133312394804' + //\
    '94707911915326734302824418604142636395480004480026704962482017928964' + //\
    '76697583183271314251702969234889627668440323260927524960357996469256' + //\
    '50493681836090032380929345958897069536534940603402166544375589004563' + //\
    '28822505452556405644824651518754711962184439658253375438856909411303' + //\
    '15095261793780029741207665147939425902989695946995565761218656196733' + //\
    '78623625612521632086286922210327488921865436480229678070576561514463' + //\
    '20469279068212073883778142335628236089632080682224680122482611771858' + //\
    '96381409183903673672220888321513755600372798394004152970028783076670' + //\
    '94447456013455641725437090697939612257142989467154357846878861444581' + //\
    '23145935719849225284716050492212424701412147805734551050080190869960' + //\
    '33027634787081081754501193071412233908663938339529425786905076431006' + //\
    '38351983438934159613185434754649556978103829309716465143840700707360' + //\
    '41123735998434522516105070270562352660127648483084076118301305279320' + //\
    '54274628654036036745328651057065874882256981579367897669742205750596' + //\
    '83440869735020141020672358502007245225632651341055924019027421624843' + //\
    '91403599895353945909440704691209140938700126456001623742880210927645' + //\
    '79310657922955249887275846101264836999892256959688159205600101655256' + //\
    '37567856672279661988578279484885583439751874454551296563443480396642' + //\
    '05579829368043522027709842942325330225763418070394769941597915945300' + //\
    '69752148293366555661567873640053666564165473217043903521329543529169' + //\
    '41459904160875320186837937023488868947915107163785290234529244077365' + //\
    '94956305100742108714261349745956151384987137570471017879573104229690' + //\
    '66670214498637464595280824369445789772330048764765241339075920434019' + //\
    '63403911473202338071509522201068256342747164602433544005152126693249' + //\
    '34196739770415956837535551667302739007497297363549645332888698440611' + //\
    '96496162773449518273695588220757355176651589855190986665393549481068' + //\
    '87320685990754079234240230092590070173196036225475647894064754834664' + //\
    '77604114632339056513433068449539790709030234604614709616968868850140' + //\
    '83470405460742958699138296682468185710318879065287036650832431974404' + //\
    '77185567893482308943106828702722809736248093996270607472645539925399' + //\
    '44280811373694338872940630792615959954626246297070625948455690347119' + //\
    '72996409089418059534393251236235508134949004364278527138315912568989' + //\
    '29519642728757394691427253436694153236100453730488198551706594121735' + //\
    '24625895487301676002988659257866285612496655235338294287854253404830' + //\
    '83307016537228563559152534784459818313411290019992059813522051173365' + //\
    '85640782648494276441137639386692480311836445369858917544264739988228' + //\
    '46218449008777697763127957226726555625962825427653183001340709223343' + //\
    '65779160128093179401718598599933849235495640057099558561134980252499' + //\
    '06698423301735035804408116855265311709957089942732870925848789443646' + //\
    '00504108922669178352587078595129834417295351953788553457374260859029' + //\
    '08176515578039059464087350612322611200937310804854852635722825768203' + //\
    '41605048466277504500312620080079980492548534694146977516493270950493' + //\
    '46393824322271885159740547021482897111777923761225788734771881968254' + //\
    '62981268685817050740272550263329044976277894423621674119186269439650' + //\
    '67151577958675648239939176042601763387045499017614364120469218237076' + //\
    '48878341968968611815581587360629386038101712158552726683008238340465' + //\
    '64758804051380801633638874216371406435495561868964112282140753302655' + //\
    '10042410489678352858829024367090488711819090949453314421828766181031' + //\
    '00735477054981596807720094746961343609286148494178501718077930681085' + //\
    '46900094458995279424398139213505586422196483491512639012803832001097' + //\
    '73868066287792397180146134324457264009737425700735921003154150893679' + //\
    '30081699805365202760072774967458400283624053460372634165542590276018' + //\
    '34840306811381855105979705664007509426087885735796037324514146786703' + //\
    '68809880609716425849759513806930944940151542222194329130217391253835' + //\
    '59150310033303251117491569691745027149433151558854039221640972291011' + //\
    '29035521815762823283182342548326111912800928252561902052630163911477' + //\
    '24733148573910777587442538761174657867116941477642144111126358355387' + //\
    '13610110232679877564102468240322648346417663698066378576813492045302' + //\
    '24081972785647198396308781543221166912246415911776732253264335686146' + //\
    '18654522268126887268445968442416107854016768142080885028005414361314' + //\
    '62308210259417375623899420757136275167457318918945628352570441335437' + //\
    '58575342698699472547031656613991999682628247270641336222178923903176' + //\
    '08542894373393561889165125042440400895271983787386480584726895462438' + //\
    '82343751788520143956005710481194988423906061369573423155907967034614' + //\
    '91434478863604103182350736502778590897578272731305048893989009923913' + //\
    '50337325085598265586708924261242947367019390772713070686917092646254' + //\
    '84232407485503660801360466895118400936686095463250021458529309500009' + //\
    '07151058236267293264537382104938724996699339424685516483261134146110' + //\
    '68026744663733437534076429402668297386522093570162638464852851490362' + //\
    '93201991996882851718395366913452224447080459239660281715655156566611' + //\
    '13598231122506289058549145097157553900243931535190902107119457300243' + //\
    '88017661503527086260253788179751947806101371500448991721002220133501' + //\
    '31060163915415895780371177927752259787428919179155224171895853616805' + //\
    '94741234193398420218745649256443462392531953135103311476394911995072' + //\
    '85843065836193536932969928983791494193940608572486396883690326556436' + //\
    '42166442576079147108699843157337496488352927693282207629472823815374' + //\
    '09961545598798259891093717126218283025848112389011968221429457667580' + //\
    '71865380650648702613389282299497257453033283896381843944770779402284' + //\
    '35988341003583854238973542439564755568409522484455413923941000162076' + //\
    '93636846776413017819659379971557468541946334893748439129742391433659' + //\
    '36041003523437770658886778113949861647874714079326385873862473288964' + //\
    '56435987746676384794665040741118256583788784548581489629612739984134' + //\
    '42726086061872455452360643153710112746809778704464094758280348769758' + //\
    '94832824123929296058294861919667091895808983320121031843034012849511' + //\
    '62035342801441276172858302435598300320420245120728725355811958401491' + //\
    '80969253395075778400067465526031446167050827682772223534191102634163' + //\
    '15714740612385042584598841990761128725805911393568960143166828317632' + //\
    '35673254170734208173322304629879928049085140947903688786878949305469' + //\
    '55703072619009502076433493359106024545086453628935456862958531315337' + //\
    '18386826561786227363716975774183023986006591481616404944965011732131' + //\
    '38957470620884748023653710311508984279927544268532779743113951435741' + //\
    '72219759799359685252285745263796289612691572357986620573408375766873' + //\
    '88426640599099350500081337543245463596750484423528487470144354541957' + //\
    '62584735642161981340734685411176688311865448937769795665172796623267' + //\
    '14810338643913751865946730024434500544995399742372328712494834706044' + //\
    '06347160632583064982979551010954183623503030945309733583446283947630' + //\
    '47756450150085075789495489313939448992161255255977014368589435858775' + //\
    '26379625597081677643800125436502371412783467926101995585224717220177' + //\
    '72370041780841942394872540680155603599839054898572354674564239058585' + //\
    '02167190313952629445543913166313453089390620467843877850542393905247' + //\
    '31362012947691874975191011472315289326772533918146607300089027768963' + //\
    '11481090220972452075916729700785058071718638105496797310016787085069' + //\
    '42070922329080703832634534520380278609905569001341371823683709919495' + //\
    '16489600755049341267876436746384902063964019766685592335654639138363' + //\
    '18574569814719621084108096188460545603903845534372914144651347494078' + //\
    '48844237721751543342603066988317683310011331086904219390310801437843' + //\
    '34151370924353013677631084913516156422698475074303297167469640666531' + //\
    '52703532546711266752246055119958183196376370761799191920357958200759' + //\
    '56053023462677579439363074630569010801149427141009391369138107258137' + //\
    '81357894005599500183542511841721360557275221035268037357265279224173' + //\
    '73605751127887218190844900617801388971077082293100279766593583875890' + //\
    '93956881485602632243937265624727760378908144588378550197028437793624' + //\
    '07825052704875816470324581290878395232453237896029841669225489649715' + //\
    '60698119218658492677040395648127810217991321741630581055459880130048' + //\
    '45629976511212415363745150056350701278159267142413421033015661653560' + //\
    '24733807843028655257222753049998837015348793008062601809623815161366' + //\
    '90334111138653851091936739383522934588832255088706450753947395204396' + //\
    '80790670868064450969865488016828743437861264538158342807530618454859' + //\
    '03798217994599681154419742536344399602902510015888272164745006820704' + //\
    '19376158454712318346007262933955054823955713725684023226821301247679' + //\
    '45226448209102356477527230820810635188991526928891084555711266039650' + //\
    '34397896278250016110153235160519655904211844949907789992007329476905' + //\
    '86857787872098290135295661397888486050978608595701773129815531495168' + //\
    '14671769597609942100361835591387778176984587581044662839988060061622' + //\
    '98486169353373865787735983361613384133853684211978938900185295691967' + //\
    '80455448285848370117096721253533875862158231013310387766827211572694' + //\
    '95181795897546939926421979155233857662316762754757035469941489290413' + //\
    '01863861194391962838870543677743224276809132365449485366768000001065' + //\
    '26248547305586159899914017076983854831887501429389089950685453076511' + //\
    '68033373222651756622075269517914422528081651716677667279303548515420' + //\
    '40238174608923283917032754257508676551178593950027933895920576682789' + //\
    '67764453184040418554010435134838953120132637836928358082719378312654' + //\
    '96174599705674507183320650345566440344904536275600112501843356073612' + //\
    '22765949278393706478426456763388188075656121689605041611390390639601' + //\
    '62022153684941092605387688714837989559999112099164646441191856827700' + //\
    '45742434340216722764455893301277815868695250694993646101756850601671' + //\
    '45354315814801054588605645501332037586454858403240298717093480910556' + //\
    '21167154684847780394475697980426318099175642280987399876697323769573' + //\
    '70158080682290459921236616890259627304306793165311494017647376938735' + //\
    '14093361833216142802149763399189835484875625298752423873077559555955' + //\
    '46519639440182184099841248982623673771467226061633643296406335728107' + //\
    '07887581640438148501884114318859882769449011932129682715888413386943' + //\
    '46828590066640806314077757725705630729400492940302420498416565479736' + //\
    '70548558044586572022763784046682337985282710578431975354179501134727' + //\
    '36257740802134768260450228515797957976474670228409995616015691089038' + //\
    '45824502679265942055503958792298185264800706837650418365620945554346' + //\
    '13513415257006597488191634135955671964965403218727160264859304903978' + //\
    '74895890661272507948282769389535217536218507962977851461884327192232' + //\
    '23810158744450528665238022532843891375273845892384422535472653098171' + //\
    '57844783421582232702069028723233005386216347988509469547200479523112' + //\
    '01504329322662827276321779088400878614802214753765781058197022263097' + //\
    '17495072127248479478169572961423658595782090830733233560348465318730' + //\
    '29302665964501371837542889755797144992465403868179921389346924474198' + //\
    '50973346267933210726868707680626399193619650440995421676278409146698' + //\
    '56925715074315740793805323925239477557441591845821562518192155233709' + //\
    '60748332923492103451462643744980559610330799414534778457469999212859' + //\
    '99993996122816152193148887693880222810830019860165494165426169685867' + //\
    '88372609587745676182507275992950893180521872924610867639958916145855' + //\
    '05839727420980909781729323930106766386824040111304024700735085782872' + //\
    '46271349463685318154696904669686939254725194139929146524238577625500' + //\
    '47485295476814795467007050347999588867695016124972282040303995463278' + //\
    '83069597624936151010243655535223069061294938859901573466102371223547' + //\
    '89112925476961760050479749280607212680392269110277722610254414922157' + //\
    '65045081206771735712027180242968106203776578837166909109418074487814' + //\
    '0490755176';

  MaxInt128S =
    '170141183460469231731687303715884105727'; // signed int128, 39 digits

  MaxCardinal128S =
    '340282366920938463463374607431768211455'; // unsigned Int128, 39 digits

  MaxCardinal256S =
    '115792089237316195423570985008687907853269984665640564039457584007913129639935';
  // 78 digits

  MaxCardinal512S =
    '13407807929942597099574024998205846127479365820592393377723561443721764030073546' +
    '976801874298166903427690031858186486050853753882811946569946433649006084095';
  // 160-5 = 145 digits

  MaxCardinal1024S =
    '17976931348623159077293051907890247336179769789423065727343008115773267580550096' +
    '31327084773224075360211201138798713933576587897688144166224928474306394741243777' +
    '67893424865485276302219601246094119453082952085005768838150682342462881473913110' +
    '540827237163350510684586298239947245938479716304835356329624224137215';
  // 320-11 = 309 digits

  MaxCardinal2048 =
    '32317006071311007300714876688669951960444102669715484032130345427524655138867890' +
    '89319720141152291346368871796092189801949411955915049092109508815238644828312063' +
    '08773673009960917501977503896521067960576383840675682767922186426197561618380943' +
    '38476170470581645852036305042887575891541065808607552399123930385521914333389668' +
    '34242068497478656456949485617603532632205807780565933102619270846031415025859286' +
    '41771167259436037184618573575983511523016459044036976132332872312271256847108202' +
    '09725157101726931323469678542580656697935045997268352998638215525166389437335543' +
    '602135433229604645318478604952148193555853611059596230655'; // 640-23 = 617 digits

  MaxCardinal4096 =
    '10443888814131525066917527107166243825799642490473837803842334832839539079715574' +
    '56848826811934997558340890106714439262837987573438185793607263236087851365277945' +
    '95697654370999834036159013438371831442807001185594622637631883939771274567233468' +
    '43445866174968079087058037040712840487401186091144679777835980290066869389768817' +
    '87785946905630190260940599579453432823469303026696443059025015972399867714215541' +
    '69383555988529148631823791443449673408781187263949647510018904134900841706167509' +
    '36683338505510329720882695507699836163694119330152137968258371880918336567512213' +
    '18492846368125550225998300412344784862595674492194617023806505913245610825731835' +
    '38008760862210283427019769820231316901767800667519548507992163641937028537512478' +
    '40149071591354599827905133996115517942711068311340905842728842797915548497829543' +
    '23534517065223269061394905987693002122963395687782878948440616007412945674919823' +
    '05057164237715481632138063104590291613692670834285644073044789997190178146576347' +
    '32238502672530598997959960907994692017746248177184498674556592501783290704731194' +
    '33165550807568221846571746373296884912819520317457002440926616910874148385078411' +
    '92980452298185733897764810312608590300130241346718972667321649151113160292078173' +
    '8033436090243804708340403154190335'; // 1280 - 46 = 1234 digits

  MaxCardinal8192 =
    '10907481356194159294629842447337828624482641619962326924318327861897213318491192' +
    '95216264234525201987223957291796157025273109870820177184063610979765077554799078' +
    '90629884219298953860982522804820515969685161359163819677188654260932456012129055' +
    '39018863010179002525357999172000100796000265358368009052978058809523505016301954' +
    '75653911005312364560014847426035293551245843928918752768696279344088055617515694' +
    '34994540667782514081490061610592025643850457801332649356583604724240738244281224' +
    '51315177575191648992263657437224322773680750276278830452065017927617009456991684' +
    '97257879683851737049996900961120515655050115561271491492515342105748966629547032' +
    '78632150573082843022166497032439613863525162640951616800542762343599630892169144' +
    '61811874063953106654048857394348328774281674074953709935118687563599703901170218' +
    '23616749458620969857006263612082706715408157066575137281027022310927564910276759' +
    '16052087830463241104936456875492096732298245918476342738379027244843801852697776' +
    '49410727156115804346908274593399919614142427414105991174260605564837637563145276' +
    '11362658628383368621157993638020878537675545336789915694234433955666315070087213' +
    '53547025567031200413072549583450835743965382893607708097855057891296790735278005' +
    '49356215610907958451729541159729274798775277385600082041185589300047777487277618' +
    '53813510493840581861598652211605960308356405941821189714037868726219481498727603' +
    '65361629885617482241303348543878532402475141941718301228107820972930353737280457' +
    '43720952287036227763639452908698062584223551485075710396193874496298668081887696' +
    '62815778153079393179093143648340761738581819563002994422790754955061288818308430' +
    '07964869323217915876591803556521615711540299212027615560787310793747746684152836' +
    '29877086994501520312318625942030856938389446570613462367042340268211029589549511' +
    '97087076546186622796294536451620756509351018906023773821539532776208676978589731' +
    '96633030889330466516943618507835064156833694453005143749131129883436726523859540' +
    '49042734559287239495252271846174043678547546104743770197680255766058810380772707' +
    '07717942221977090385438585844095492116099852538903974655703943973086090930596963' +
    '36076752996493841459818570596375456149735582781362383328890630900428801732142480' +
    '86639626713335280092327583508730596141187237814221014601986157473868550968960891' +
    '89180441339558524822867541113212638793675567650340362970031930023397828465318547' +
    '23824423202801518968966041882297600081543761065225427016359565087543385114712321' +
    '4227266605403581781469090806576468950587661997186505665475715792895'; // 2467 digits

  MaxCardinal16378 =
    '18589554614956746329464989478562611418178823235882972460510544081769708721570057' +
    '60788263430425956312367367871070061420717027605283294824103553944841158695322001' +
    '36192869688265237834883065551788569680054017106583726099476166379841372611606401' +
    '22587720913688192787576345670395107114269314979624998215470411828408137740051887' +
    '20256755801183069204083448242503777133318672293562639167995894172829430699290243' +
    '40748973690970851859971540567295361147476665240525101507061450496608088696713344' +
    '57579899314599528020026967000248568979301403633407240925545134373421572236156642' +
    '52616362581050686439567497504597977095885861366779710302838903576553820583438069' +
    '71551308927824126772779976339624230807880881904959982757013340263240362850095037' +
    '35610334366807427105309125257683478460706703356994880249654643099958347286714606' +
    '42877582933997267170196923273108757306489225401968971573160980606255378049148949' +
    '53374698637748374557720932126318672653620508603481566660343757506585907531250322' +
    '03022401269337872779384804370735513710669350604766375533822395890834146968719385' +
    '96732284980158757840919160271443384811313748330808920012346469164699892150655701' +
    '37167125627737139365419998138751397539259191714013806905333429028149663182022820' +
    '73650866482911362303570810860941854611239429637635994225565530118635817887825200' +
    '53589631997948221975264128841492400831336016419046706041948224687371324292642768' +
    '08359484533624618608977037505161175106799721327218068233762148142280982015834939' +
    '29206473033153288985593426180572580702872657219547914329447615147875572508895929' +
    '13808081536488995115487566625005643154358247180796956397754314541724299750515797' +
    '88297186786744941670104629338096969428512555922877399095739522930636407329232636' +
    '01501953907314947800824395276001023411679572840606625973628287644915383837301013' +
    '22527578375192462303179259784308264189790933830552860538163608904116802543391181' +
    '60488460164460800817101256273299186825212480620080126339881917479914914700764841' +
    '58672199918859077175244657114361963151267280725846249241826696611401898489044009' +
    '14284489158563887534015341153776764682622455405587259457161160825698827662028981' +
    '44577464987646320316039285507804621985656869700444929831545492520831413751870919' +
    '31821528523958218575814942584989609708051752095021725797207115057935992123702548' +
    '84256564324808109545211337366467950338901746786358396263498553863738673619867386' +
    '10374441418961492677689617639146844156715413331217984527567646733113228160762330' +
    '14072722033098239035917302846245581008899070553172330832926444599871712010534681' +
    '88689767458750965237792174864635682865448752471986915419136145475802054839491739' +
    '75426303219787951626015099391319252773876754292192056696577144953289007265553159' +
    '52874717699790831316472288503807650157928592549963104399153711902711493265383375' +
    '83792553787932977751445100037158796352384867048292125762614805026570501775487297' +
    '56238400391979067588470898502608706237449097376657300737714604880315877115736279' +
    '41248589093311624130429379909654748223715121561274060815270849130764180473731263' +
    '02416956788078636077006480471313421013253126959745916687616339596735834023268687' +
    '00158830635797835922745691532952435459192666795344515682597525984682586407138600' +
    '04454616413825626148885059790162558861832601755941486093039357140835571690457812' +
    '56466952681067406040736793085650744886929869430410631876738611550826844641865927' +
    '22294815367689499854526913702686167854399673780620905342626140451086306422012541' +
    '29043770639500625186377405793767667833430468801547123827785311515224355098220999' +
    '69562675709951986115755856123449692822806752114714068857608505321050219806193189' +
    '05844532691531797761363510171172854271760764441306962796509672952878779182889224' +
    '27251256238255110904870513767815162252844665650230598190636721617192646226557685' +
    '37604047718219857921152158752949498510402749460293753026746517726091135044988473' +
    '27240315017569614615538607415945275532679303453007627425218113966876204870627796' +
    '07778026665691773140393141075241543561111890298647225524336705795397531662457432' +
    '73880011414581008468735545855953943759678433125924456481042490150397402914033755' +
    '98929117844015723252804246487205502761617502579870679332457355503133777773159207' +
    '59330599167883458392302475433717494696290373184738471546276434175408107275511952' +
    '09826206884155866996499795680516646765527970615018232824175554291188694690425690' +
    '67403116271847557316984185970769218152217613847795581259001954585796950397806898' +
    '75726217579913226573940064204677269684366495157743387323224960735342950855453513' +
    '49387377902865946552808107554343212927311113107165166288806842300555328573104716' +
    '44906508427221857556415929636243914854482337729377974317148347513529249225156938' +
    '26801038691761891726743256047865644752133081831428279944668692931639831498508342' +
    '76892089875727809844024075027404472363623503689120514592025915668984447806373238' +
    '19432119450085263911496243078591936987460082533278772277888117813294416301207943' +
    '90397187834516710709567512582320626471043732439225227862037351155976389050438934' +
    '659592723254619995583905361757194484801416718188544'; // 80x61+51= 4931 digits

  MaxCardinal32768 =
    '14154610310449547890015530277449516013481307114723881672343857482723666342408452' +
    '53596025356476648415075475872961656126492389808579544737848881938296250873191743' +
    '92779354491301105016265127795702984696021178324293352120754541348496985685185114' +
    '12885151632014829953890550974606220986356750033539292242785829356644162625727733' +
    '08153277514346480313371988612629481483562438178928958867777850072198316174841251' +
    '95559099667201864509364085080367963022036720138384486679144928473751826281312308' +
    '34390372436784404208971399237782789527703123187783290048945470654890775968353960' +
    '17153603170050371302014762443872701111379554484309718662306883776010475348441493' +
    '60049194347904127199292019533198306493010616472724143894087768516465894865488617' +
    '16411244739756262416327501501266553699810212935700660423054824860408831656358628' +
    '35728637046058352403756085745691239473897891999085976345203704659967157427239535' +
    '83650713365690881524608013919556946107200630159037295483073864439113801606534413' +
    '11312076042640538974408289046620471832343775474272876919417415359465108829909044' +
    '77863185473798528388060457568927943633923928872681927502029572963130840854853739' +
    '93707688103564617938305548343387605140203761442474890296901815918651981105154536' +
    '79671037671828197091354790191316833093307973744081973398315272390407159081122130' +
    '95126770717606001288898889370710896248862361503869205214536908258196921765593065' +
    '32539283633214259441113460347550936602814569030635060185929526129626333101868227' +
    '63175677495345710587722355676795569202407891090705212539871310312639022930347443' +
    '67356932509952188828475362311316445284228640489421809263738423630931243024914587' +
    '86392813471918610416466060535600159196277864637829541365977078264697923628906261' +
    '64424180715710392825512893488482745228930595617178601940346982418048875312750781' +
    '09603637160495907579995366419636417028927573391670580796818526074226095014375189' +
    '43857921607167754076608560560410612303666966743467772347267556445899167126841410' +
    '08010314539177366659472849566748840353066212864651837986938525998033246198651818' +
    '56244422079233687294508536408521087418873908498202710597080474480249818858011490' +
    '93051851271379880362910163871627857887414521442902618627660228901248452683007664' +
    '73568287648783277267198164286789042079444568943931859830903470451768867323262539' +
    '12297649524439880403701430566761380359925558522718201954287517587367247510777678' +
    '93466447254864778704830633077086237001552585800547975647149922724490114280574976' +
    '95641847532119672232262129641656788566048924169849150974229605341223334538769812' +
    '79243565766391796311605149222628328255333061543877525846029404507128890053189442' +
    '52754466514151357113618712687491460166975039248610050756844204683178063103254057' +
    '40779442744542280876392417368185051637599103651319906329474629932045852181224319' +
    '92323864244947394390438656356424037471932484452186545692102503479070599953823165' +
    '19421101969676057526442680284830303180430573353222805018028603417516891882746062' +
    '60422686582951407069150471890494925789966504940058823370711500048689561934065931' +
    '84838633694068409823903437144417376039174235011053228846851424217955172902918651' +
    '00361098410840265092935939630563431304708872511303907681194009010985557828593782' +
    '91642135766128222103479577459473310474825253466025426531768998092788082327965575' +
    '31832150249769253600667902268029661700149632868541956266119528042486534014778779' +
    '84698176103315500726273016267595452022188738471038705172182927191759229505716958' +
    '95397063616710820948094058717904686232348959147964643900192591675137718648328690' +
    '36015645542195008456098615038348028400803005801944957156282746379539470250603755' +
    '46535878628147608604456789371513063591494608536161237274273263803737228763389711' +
    '83032500363558977582095690102460515634291092558649382455245502005802182743148097' +
    '38075022775651220374105227215906205292751918667060475328593225367793061070422108' +
    '73380098385550759180641346096458559531635997117928428360473146866854548476138174' +
    '75916397364534198964493234863970307763977612025904676375054733902222494567240932' +
    '38682557762781839530938233751281999608711356147835655195236666056355678841889862' +
    '28401467405905299517022071140444501276664220331459237171259487796834326521023279' +
    '81350232991173181917703651238070867043818097596022601516129968969942941860844756' +
    '19138121455294389585874237791634701296124550179672059485838256445846530599137662' +
    '48084134437650398924463334501607088719812042143557572623718931216181802154800638' +
    '95011823934417121420449530722640166767990116246203122464685546543715447173552277' +
    '40157629086739710675845209992133342035144038961065892653392182875622932670067798' +
    '43393489170951987785079421949144798816017193233100649562028009414946437945015308' +
    '54062250814718795858940879160921416237523451127510677031664036811623319202917408' +
    '47388957632311053342426152947324011627922225878539935022974616062774839110489080' +
    '09417497284106810200664567749929376909136285371930095877522208867090972389541486' +
    '64644007563144702819620342765315125440097261746493999375817397181179824173609859' +
    '58259468485436586733686659771030677664677905401522360041892481951454135360540917' +
    '41109841228672383067271291060338674813634887805654574611214211111665998578239827' +
    '56271224494143071407494048840607538637060242810314855386661333328355978175146163' +
    '31728118982180628823657668668099621799842011158020767772792912298768785614574416' +
    '01932054619679348601867788455071587060800498882997814896698077013688435322694985' +
    '36545416558370294980170310859436604404660760194794351810454368978453510487884401' +
    '02268677798257134774081674357195358847761226603653040273985441982221318087815835' +
    '10731757121184121582560645334852109793641352029599826075104077870374036630987199' +
    '91147174410691828257829962994116230874150089109413032841821315847998162107280342' +
    '55555687956785287887098941927737599159824398527573423117728252839768919145018117' +
    '99559794628226494652374169118085844119437338709896953012683401492365662784912906' +
    '21891455728702122259094645309195316340902063711463216637972798057600284952880848' +
    '48179380053931435604182517516600823936737919915974103591167638898871754018470172' +
    '58923498939705189302857436528889030378023919462253821553221273555529939754284535' +
    '06293615603471954592867295611682353834289308283788876781975906241103722673387566' +
    '68414899526138480866747114831414687579691636020586013635675559033488649721062244' +
    '14278796040405696130617602298124284098482542179715039390971388499070800865432755' +
    '80256190742132707142524315151716389945057201443475021858485281290000556297034226' +
    '95425047209518177577128511315492059613722366724615343968357332924191178041956753' +
    '13294159632210125041706881397730349803394061379109972017478677384469673403401026' +
    '91395538782123871085081586228397335936349189756166133682438828083915092448068093' +
    '37882965338701545504691589517650472239580754189547649790038026506707709763098148' +
    '74652403101380053189087685822736050167616187466194643164792957255599296729855347' +
    '11526934714524801198976081733367532601244525108153334164093570296332651726142036' +
    '63326409976153102467083379129588112837280711111346490898947808402062401228963194' +
    '16271165742299842926357927651541400097905374066273381663298150853512851844025800' +
    '67823922888609038232074368207930418819070937918749176358298548081506408949071276' +
    '00430185202301457398493533111918994100853753771956293430162566011361163168953462' +
    '18801023181900021366978044785687124856437758450908588879788374753830918181070061' +
    '50322255630910166894747802534125713386255818179210615493525575883236595626756505' +
    '63535186144754433556539747098322643609542486120512917463706713059064230762924353' +
    '61797205349252711919265817185134595770077257184199817603626939988901248074507592' +
    '49804793903493327341027744000081200734615405405710515069710039046234843447620051' +
    '26345905465893817895377928139596549936720100490013375956605889200767596688065961' +
    '07600347200558589022259465501043012312735166531686266348478596644626374062456487' +
    '53516407809237030068681074407902716829360433048735796489899785717548988407891844' +
    '80129570446991029504758616393106487523321312507454036808667210073602144290050619' +
    '61061473813954328564934698639321310245686379366551253365593194179053761902060473' +
    '06014431812506620196874917115473605971178569772408171100397371533552124547459077' +
    '87131179578656470567535050192702347739653312290522505871612897990429961857550031' +
    '03366572564798798275186840729473043731950533578242529032442799430837496080668443' +
    '54164459078171071682983429451829855941112814994724957495016424180427346811585604' +
    '50241309279063816746067016274795461832774699007774423895748677615395848493765672' +
    '27195727866454634316160912681002825421465963362522393450893169172858402834235666' +
    '93326354580799571478337895016968357817482348849190935742763303545778419752496038' +
    '99105407104895787598263630679206627796433754045597409176502438867600537016879169' +
    '91447475484002431192216964738837995280252384708010243928511256575167772637320168' +
    '84032544667890707135752142561924524490291100405379946274245324036201798800565187' +
    '21219108771374073638118719073211367295514376708596537294204544099903590754371656' +
    '17865696017021767583215326816459167400450023907374350264809910562454858749354482' +
    '54792705897424944951812237223296933454686393069905231189956405670425313695771311' +
    '13159027381808071346991604513906450398219426300899204662435492578485666553974492' +
    '72317385977748541292701606834151551743711513705037275027927854833279919379940015' +
    '41664428014273100765370201199360734952219747919397598461689420553973573482781780' +
    '50441024490005893818256958665388971201322931680573846084525016332224646866617490' +
    '83249608499169017158302935260983649090811346466834382998535159055294528437257397' +
    '82954850979508930724235186059820854871544701550252690258540446464965724484952253' +
    '43096261896378931482883286657508859228868487844184479087538453974144187004884366' +
    '56125672340477219084758600854396134907113119170894329533766438418453277466150324' +
    '59102574519235156077115597054781325560401976634149118851436979854648073092970029' +
    '10250505302287769412337441199360424519160716552890882816796378296881641827981453' +
    '03520723375206351878277849374382770810991349316293218242762726104628016826995807' +
    '7541122668104633712377855'; // 80*123+25 = 9865 digits

  MaxCardinal65536 =
    '20035299304068464649790723515602557504478254755697514192650169737108940595563114' +
    '53089506130880933348101038234342907263181822949382118812668869506364761547029165' +
    '04187191635158796634721944293092798208430910485599057015931895963952486337236720' +
    '30029169695921561087649488892540908059114570376752085002066715637023661263597471' +
    '44807111774815880914135742720967190151836282560618091458852699826141425030123391' +
    '10827360384376787644904320596037912449090570756031403507616256247603186379312648' +
    '47037437829549756137709816046144133086921181024859591523801953310302921628001605' +
    '68670105651646750568038741529463842244845292537361442533614373729088303794601274' +
    '72495841486491593064725201515569392262818069165079638106413227530726714399815850' +
    '88112926289011342377827055674210800700652839633221550778312142885516755540733451' +
    '07213112427399562982719769150054883905223804357045848197956393157853510018992000' +
    '02414196370681355984046403947219401606951769015611972698233789001764151719005113' +
    '34663068981402193834814354263873065395529696913880241581618595611006403621197961' +
    '01859534802787167200122604642492385111393400464351623867567078745259464670903886' +
    '54774348321789701276445552940909202195958575162297333357615955239488529757995402' +
    '84719435299135437637059869289137571537400019863943324648900525431066296691652434' +
    '19174691389632476560289415199775477703138064781342309596190960654591300890188887' +
    '58808473362595606544488850144733570605881709016210849971452956834406197969056546' +
    '98136311620535793697914032363284962330464210661362002201757878518574091620504897' +
    '11781820400187282939943446186224328009837323764931814789848119452713007440220765' +
    '68091037620399920349202390662626449190916798546151577883906039772075927937885224' +
    '12943010174580868622633692847258514030396155585643303854506886522131148136384083' +
    '84778263790459607186876728509763471271988890680478243230394718650525660978150729' +
    '86114143030581692792497140916105941718535227588750447759221830115878070197553572' +
    '22414000195481020056617735897814995323252085897534635470077866904064290167638081' +
    '61740550405117670093673202804549339027992491867306539931640720492238474815280619' +
    '16690093380573212081635070763435166986962502096902316285935007187419057916124153' +
    '68975148082619048479465717366010058924766554458408383347905441448176842553272073' +
    '15586349347605137419779525190365032198020108764738368682531025183377533908861426' +
    '18480037400808223810407646887847164755294532694766170042446106331123802113458869' +
    '45322001165640763270230742924260515828110703870183453245676356259514300320374327' +
    '40780879056283663406965030844225855967039271869461158513793386475699748568670079' +
    '82396060439347885086164926030494506174341236582835214480672667684180708375486221' +
    '14082365798029612000274413244384324023312574035450193524287764308802328508558860' +
    '89962774458164680857875115807014743763867976955049991643998284357290415378143438' +
    '84730348426190338884149403136613985425763557710533558020662218557706008255128889' +
    '33322264362819848386132395706761914096385338323743437588308592337222846442879962' +
    '45605476932428998432652677378373173288063210753211238680604674708428051166488709' +
    '08477029120816110491255559832236624486855665140268464120969498259056551921618810' +
    '43412268389962830716548685255369148502995396755039549383718534059000961874894739' +
    '92880432496373165753803673586710175783994818471798498246948060532081996066183434' +
    '01247609663951977802144119975254670408060849934417825628509272652370989865153946' +
    '21930046073645079262129759176982938923670151709920915315678144397912484757062378' +
    '04600009918293321306880570046591458387208088016887445835557926258465124763087148' +
    '56631352893416611749061752667149267217612833084527393646924458289257138887783905' +
    '63004824837998396920292222154861459023734782226825216399574408017271441461795592' +
    '26175083889020074169926238300282286249284182671243405751424188569994272331606998' +
    '71298688277182061721445314257494401506613946316919762918150657974552623619122484' +
    '80638900336690743659892263495641146655030629659601997206362026035219177767406687' +
    '77463549375318899587866282125469797102065747232721372918144666659421872003474508' +
    '94283091153518927111428710837615922238027660532782335166155514936937577846667014' +
    '57179719012271178127804502400263847587883393968179629506907988171216906869295382' +
    '48529830023476068454114178139110648560236549754227497231007615131870024053910510' +
    '91381784372179142252858743209852495787803468370333781842144401713868812424998441' +
    '86181292711985333153825673218704215306311977485352146709553346263366108646673322' +
    '92409879849256691109516143618601548909740241913509623043612196128165950518666022' +
    '03071561368473236466086890501426391390651506390819937885231836505989729912540447' +
    '94434251667742996598118492331515552728832740283526884424087528112832899806259126' +
    '73699546247341543333500147231430612750390307397135252069338173843322950701049061' +
    '86753943313078479801565513038475815568523621801041965025559618193498631591323303' +
    '60964619059902361126811960234418433633345949276319461017166529138237171823942992' +
    '16272538461776065694542297877071383198817036964588689811863210976900355735884624' +
    '46483570629145305275710127887202796536447972402540544813274839179412882642383517' +
    '19491972097971459368875371987291308317380339110161285474153773777159517280841116' +
    '27597186384924222802373441925469991983672192131287035585307966942713416391033882' +
    '75431861364349010094319740904733101447629986172542442335561223743571582593338280' +
    '49862438924982227807159517627578471094751190334822414120251826887137281931042534' +
    '78196128440176479531505057110722974314569915223451643121848657575786528197564843' +
    '50895838472292353455946452121583165775147129870822590929265563883665112068194383' +
    '69041162526687100445602437042006637090019411855571604720446436969328500600469281' +
    '40507119069261393993902735534545567470314903886022024639948260501762431969305640' +
    '66636662609020704888743889890749815286544438186291738290105182086993638266186830' +
    '39152732645812867828066013375000965933646251460917231803129303478774212346791184' +
    '54791311109897794648216922505629399956793483801699157439700537542134485874586856' +
    '04728675106542334189383909911058646559511364606105515683854121745980180713316361' +
    '25730796111683438637676673073545834947897883163301292408008363568259391571131309' +
    '78030516441716682518346573675934198084958947940983292500086389778563494693212473' +
    '42610306271374507728615692259662857385790553324064184901845132828463270926975383' +
    '08673084091422476594744399733481308109863994173797896570106870267341619671965915' +
    '99588537834822988270125605842365589539690306474965584147981310997157542043256395' +
    '77607048510088157829140825077773855979012912940730946278594450585941227319481275' +
    '32251523248015034665190482289614066468903051025109162377704484862302294889667113' +
    '80555607956620732449373374027836767300203011615227008921843515652121379215748206' +
    '85935692079021450227713309998772945959695281704458218195608096581170279806266989' +
    '12050615607423256868422713062950098644218534708104071289176469065508361299166947' +
    '78023822502789667843489199409657361704586786242554006942516693979292624714524945' +
    '40885842272615375526007190433632919637577750217600519580069384763578958687848953' +
    '68721228985578068265181927036320994801558744555751753127364714212955364940843855' +
    '86615208012115079075068553344489258693283859653013272046970694571546959353658571' +
    '78889486233329246520273585318853337094845540333656535698817258252891805663548836' +
    '37437933484118455801683318276768346462919956055134700391478768086403226296166415' +
    '60667508153710646723108461964247537490553744805318226002710216400980584497526023' +
    '03564003808347205314994117296573678506642140084269649710324191918212121320693976' +
    '91439233683747092282677387081322366800869247034915868409911530983154120635661231' +
    '87504305467536983230827966457417620806593177265685841681837966106144963432544111' +
    '70694170022265781735835125982108076910196105222926387974504901925431190062056190' +
    '65774524161919131875339840493439768233102984658933183730158095925228292068208622' +
    '30332585280119266496314441316442773003237792274712330696417149945532261035475145' +
    '63129066885434542686978844774298177749371011761465162418361668025481529633530849' +
    '08499430067636548061029400946937506098455885580439704859144495844450799784970455' +
    '83550685408745163316464118083123079704389849190506587586425810738422420591191941' +
    '67418249045270028826398305795005734171148703118714283418449915345670291528010448' +
    '51451760553069714417613685823841027876593246626899784183196203122624211773914772' +
    '08004883578333569204533935953254564897028558589735505751235129536540502842081022' +
    '78524877660357424636667314868027948605244578267362623085297826505711462484659591' +
    '42102781227889414481639949738818846227682448516220518170767221698632657016543169' +
    '19742651230041757329904473537672536845792754365412826553581858046840069367718605' +
    '02007054724754840080553042495185449526724726134731817474218007857469346544713603' +
    '69758841180294080396167469462885406791721386012254195038197045384172680063988206' +
    '56328792839582708510919958839448297775647152026132871089526163417707151642899487' +
    '95356485455355314875497813400996485449863582484769059003311696130376612792346432' +
    '31297066284113074270462020320133683503854253603136367635752126047074253112092334' +
    '02837482949453104727418969287275572027615272268283376741393425652653283068469997' +
    '59709775000556088993268502504921288406827413988163154045649035077587168007405568' +
    '57240217586854390532281337707074158307562696283169556874240605277264858530506113' +
    '56384851965918968649596335568216975437621430778665934730450164822432964891270709' +
    '89807667662567151726906205881554966638257382927418208227896068448822298339481667' +
    '09840390242835143068137672534601260072692629694686727507943461904399966189796119' +
    '28750519442356402644303271737341591281496056168353988188569484045342311424613559' +
    '92527233006488162746672352375123431189344211888508507935816384899448754475633168' +
    '92138696755743027379537852625423290248810471819390372206668947022042588368958409' +
    '39998453560948869946833852579675161882159410981624918741813364726965123980677561' +
    '94791255795744647142786862405375057610420426714936608498023827468057598259133100' +
    '69199419046519065311719089260779491192179464073551296338645230356733455880333131' +
    '97080365457184791550432654899559705862888286866606618021882248602144999973122164' +
    '13817065348017551043840662441282280361664890425737764095632648282525840766904560' +
    '84394903252905263375323165090876813366142423983095308065496618793819491200339194' +
    '89494065132398816642080088395554942237096734840072642705701165089075196155370186' +
    '26479745638118785617545711340047381076276301495330973517418065547911266093803431' +
    '13785325328835333520249343659791293412848549709468263290758301930726653377825593' +
    '14331110963848053940859283988907796210479847919686876539987477095912788727475874' +
    '43980677982496827827220092644994455938041460877064194181044075826980568803894965' +
    '46165879839046605876453418102899071942930217745199761044950431968415034555140448' +
    '20928933378657363052830619990077748726922998608279053171691876578860908941817057' +
    '99340489021844155979109267686279659758395248392673488363474565168701616624064242' +
    '42412289611180106156823425393921800524834547237792199112285959141918774917938233' +
    '40010078128326506710281781396029120914720100947878752551263372884222353869490067' +
    '92766451163475810119387531965724212147603828477477457170457861041738574791130190' +
    '85838778901523343430130052827970385803598151829296003056826120919509437373254541' +
    '71056383887047528950563961029843641360935641632589408137981511693338619797339821' +
    '67076100460798009601602482309694304380695662012321365014054958625061528258803302' +
    '29083858124784693157203232336018994694376477267218793768264318283826035645206994' +
    '68630216048874528424363593558622333506235945002890558581611275341783750455936126' +
    '13085264082805121387317749020024955273873458595640516083058305377073253397155262' +
    '04447054295735383611136775231699727402929416742044232481138750756313190782721888' +
    '64053374694213842169928862940479635305150560788126366206497231257579019598873041' +
    '19562622734372890051656111109411174527796548279047125058199907749806382155937688' +
    '55464988229389854082913251290764783863224947810167534916934892881042030156102833' +
    '86143827378160946341335383578340765314321417150655877547820252454780657301342277' +
    '47061674424196895261316427410469547462148375628829977180418678508454696561915090' +
    '86958742511844358373065909514609804512474094113738999278224929833677960110153870' +
    '96129749705566301637307202750734759922943792393824427421186158236161317886392553' +
    '09511718842129850830723825972914414225157940388301135908333165185823496722125962' +
    '18125070581137594955250227472746743698871319266707692991990844671612287388584575' +
    '84622726573330753735572823951616964175198675012681745429323738294143824814377139' +
    '86190671665757294580780482055951188168718807521297183263644215533678775127476694' +
    '07901170575098195750845635652173895441798750745238544552001335720333323798950743' +
    '93905312918212255259833790909463630202185353848854825062897715616963860712382771' +
    '72562131346054940177041358173193176337013633225281912754719144345092071184883836' +
    '68181742633429496118700915030491653394647637177664391207983474946273978221715020' +
    '90670190302469762151278521956142070806461631373236517853976292092025500288962012' +
    '97014137964003805573494926907353514596120867479654773369295877362863566014376796' +
    '40384307968641385634478013282612845891848985280480488441808216394239740143629034' +
    '81665458114454366460032490618763039502356402044530748210241366895196644221339200' +
    '75747912868380517515063466256939193774028351207566626082989049187728783385217852' +
    '27920457718469658552787904475621926639920084093020756739253637356283908298175779' +
    '02153202106409617373283598494066652141198183810884515459772895164572131897797907' +
    '49194101314836854463961690460703010759681893374121757598816512700076126278916951' +
    '04063158576375347874200702220510708912576123616580268068158584998526314658780866' +
    '16800733264676830206391697203064894405628195406190685242003053463156621891327309' +
    '06968735318164109451428803660599522024824888671155442910472192913424834643870536' +
    '85086487490991788126705656653871910497218200423714927401644609434598453925367061' +
    '32210616533085662021188968234005752675486101476993688738209584552211571923479686' +
    '88816085363161586288015039594941852948922707441082820716930338781808493620401825' +
    '52222710109856534448172074707560192459155994310729495781978785905789400525401228' +
    '67517142511184356437184053563024181225473266093302710397968091064939272722683035' +
    '41046763259135527968383770501985523462122285841055711992173171796980433931770775' +
    '07556270560478317798444476375602546370333692471142208155199736913719751632413027' +
    '48712199863404548248524570118553342675264715978310731245663429805221455494156252' +
    '72402891533335434934121786203700726031527987077187249123449447714790952073476138' +
    '54254853115527733010303424768358654960937223240071545181297326920810584240905577' +
    '25645803681462234493189708138897143299831347617799679712453782310703739151473878' +
    '69211918756670031932128189680332269659445928621060743882741691946516226763254066' +
    '50708810710303941788605648937698167341590259251946118236429456526693722031555047' +
    '00213598846292758012527715422016629954863130324912311029627923723899766416803497' +
    '14122652793190763632613681414551637665655983978848938173308266877990196288693229' +
    '65973799519316211872154552873941702436698855938887933167445333631195415184040882' +
    '83815193421234122820030950313341050704760159987985472529190665222479319715440331' +
    '79483683737322082188577334162385644138070054191353024594391350255453188645479625' +
    '22602517629283743304651023610575835145507394433396102162296754614157811271970017' +
    '38611494279501411253280621254775810512972088465263158094806633687670147310733540' +
    '71771087661593585681409821296773075919738297344144525668877085532457088895832099' +
    '38234321027182241147637327913575686154212528496579033350931527769255058456440105' +
    '52192644505312073756287744998163646332835816140330175813967359427327690448920361' +
    '88038675495575180689005853292720149392350052584514670698262854825788326739873522' +
    '04572282392902071448222198855871028969919358730742778151597576207640239512438602' +
    '02032596596250212578349957710085626386118233813318509014686577064010676278617583' +
    '77277289589274603940393033727187385053691295712671506689668849388088514294360996' +
    '20129667590792250822753138128498515269029317002631363289420957975779593276355311' +
    '62066753488651317323872438748063513314512644889967589828812925480076425186586490' +
    '24111112730135719718138160258317850693224400799865663537154408845486639318170839' +
    '57357807990597308390948818040609359591909074739609044101505163217496814121007657' +
    '19177483767355751000733616922386537429079457803200042337452807566153042929014495' +
    '78062963413838355178359976470885134900485697369796523869584599459559209070905895' +
    '68914511414126845054621179450266117501669282602509507707782119504326173832235624' +
    '37601776799362796099368975191394965033358507155418436456852616674243688920371037' +
    '49532842592713161053783498074073915863381796765842525803673720646935124865223848' +
    '13416638080615057048290598906964519364400185971204257230073164100099169875242603' +
    '77362177763430621616744884930810929901009517974541564251204822086714586849255132' +
    '44426677712786372821133153622430109182439124338021404624222334915355951689081628' +
    '84879899882736304453724321742802157557779670216663170479697281724833928410156422' +
    '74507271779269399929740308072770395013581545142494049026536105825409373114653104' +
    '94338248437971860693721444460082679800247122948940576185389220342560830269705287' +
    '66213773735943942241147070740729027254613073585417456914194464876243576823970657' +
    '03184168467540733466346293673983620004041400714054277632480132742202685393698869' +
    '78760700959004868465062677136307097982100655728510130660101078063374334477307347' +
    '86538817426812307437660666433127753564665786037151929227684404582732832438082128' +
    '41218776132042460464900801054731426749260826922155637405486241717031027919996942' +
    '64562095561981645454766204502241144940474934983220680719135276798674781345820385' +
    '95704134661779372285349400316315995440936840895725334387029867178297703733328068' +
    '01764639502090023941931499115009105276821119510999063166150311585582835582607179' +
    '41005252858361136996130344279017381178741206128818206202326384986151565645123004' +
    '77929675636183457681050433417695430675380411139285537925292413473394810505320257' +
    '08728186307291158911335942014761872664291564036371927602306283840650425441742335' +
    '46454998705531872688792642410214736369862546374715974435494344389973005174252511' +
    '08773578863909468120966734281525859199248576404880550713298142993599114632399191' +
    '13959926752576359007446572810191805841807342227734721397723218231771716916400108' +
    '82611254909336118678057572239101818616854910850088527227437421208652485237245624' +
    '86976622453848192986711294529455154970305859193071984971054141816369689761311267' +
    '44027009648667545934567059936995464500558921628047976365686133316563907395703272' +
    '03438917541526750091501119885687270884819553167693168127289214303137681801644547' +
    '73675183534978579242764633541624336011259602521095016122641103460834656482355979' +
    '34274056868849224458745493776752120324703803035491157544831295275891939893680876' +
    '32768543876955769488142284431199859570072752139317683783177033913042306095899913' +
    '73146845690104220951619670705064202567338734461156552761759927271518776600102389' +
    '44760539789516945708802728736225121076224091810066700883474737605156285533943565' +
    '84375627124124445765166306408593950794755092046393224520253546363444479175566172' +
    '59621871992791865754908578529500128402290350615149373101070094461510116137124237' +
    '61426722541732055959202782129325725947146417224977321316381845326555279604270541' +
    '87149623658525245864893325414506264233788565146467060429856478196846159366328895' +
    '42997807225422647904006160197519750074605451500602918066382714970161109879513366' +
    '33771378434416194053121445291855180136575558667615019373029691932076120009255065' +
    '08158327550849934076879725236998702356793102680413674571895664143185267905471716' +
    '99629903630155456450900448027890557019683283136307189976991531666792089587685722' +
    '90600915472919636381673596673959975710326015571920237348580521128117458610065152' +
    '59888384311451189488055212914577569914657753004138471712457796504817585639507289' +
    '5337539755822087777506072339445587895905719156735'; // 80*246+49 = 19729 digits
{$ENDIF BIGNUM_CONSTS}

implementation

end.

